﻿using Jose;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.Serialization.Formatters.Binary;
using System.Security.Cryptography.X509Certificates;

namespace joseencryption
{
    class Program
    {

        // used Nuget Packages --- 1. NewtonSoft JSON 2. jose-jwt

        static byte[] key; // This must be a 256bit size  
        static void Main(string[] args)
        {

            var aes = Aes.Create();
                aes.KeySize = 256;
                aes.GenerateKey();
            key =  aes.Key;

            var payload = new PlainPayload()
            {
                pgMerchantId = "AR7399228922004061",
                txnId = "83a34d20c72445329c10c3f79594dbf5",
                ts = "2022-10-18T14=37=27Z",
                mebussname = "PQR",
                legalStrName = "PQR",
                merVirtualAdd = "69748f72745@induspay",
                awlmcc = "6211",
                strCntMobile = "8908765410",
                merchantType = "LARGE",
                panNo = "NJQPS9526F",
                gstNumber = "18NJQPS9526F1ZM",
                extMID = " ",
                extTID = " ",
                accNo = "1000111100001",
                ifscCode = "INDB0EPH000",
                accType = "CURRENT",
                meEmailID = "abc@gmail.com",
                onboardingType = "AGGREGATOR",
                merchantGenre = "ONLINE",
                ownerShipType = "PROPRIETARY",
                kycFlag = "Y"
            };
            var payloadText = Newtonsoft.Json.JsonConvert.SerializeObject(payload);
            Console.WriteLine("payloadText \t" + payloadText);

            var encryptedText = Encrypt(payloadText);

            

            Console.WriteLine("Envrypted Text \t" + encryptedText);

            EncryptedPayload encryptedPayload = new EncryptedPayload();
            encryptedPayload.bit = 0;
            encryptedPayload.key = EncryptKey(ToHexString(key));
            encryptedPayload.data = encryptedText;

            CallAPI(encryptedPayload);

            Console.ReadLine();
        }

        public static string ToHexString(byte[] bytes)
        {
            var sb = new StringBuilder();
            foreach (var t in bytes)
            {
                sb.Append(t.ToString("X2"));
            }

            return sb.ToString(); // returns: "48656C6C6F20776F726C64" for "Hello world"
        }

        static async void CallAPI(EncryptedPayload payload)
        {
            ServicePointManager.Expect100Continue = true;
            ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls12;
            var json = Newtonsoft.Json.JsonConvert.SerializeObject(payload);

            var data = new StringContent(json, Encoding.UTF8, "application/json");

            var url = "https://indusapiuat.indusind.com/indusapi-np/uat/eph-upi/merchantOnboard/v2";
            var client = new HttpClient();
            client.DefaultRequestHeaders.Add("IBL-Client-Id", "24de643d1faf51db34615c186b5c63d6");
            client.DefaultRequestHeaders.Add("IBL-Client-Secret", "8b7df79708322c55fe306989db5b360d");

            var response = await client.PostAsync(url, data);

            var result = await response.Content.ReadAsStringAsync();

            var resp = Decrypt(result);

            Console.WriteLine(resp);
        }

        static string Encrypt(string payloadText)
        {
            var encoded = JWT.Encode(payloadText, key, JweAlgorithm.A256KW, JweEncryption.A256GCM);

            return encoded;
        }

        static string Decrypt(string encryptedResponse)
        {
            var encryptedObj = Newtonsoft.Json.JsonConvert.DeserializeObject<EncryptedResponse>(encryptedResponse);

            var jwt = JWT.Decode(encryptedObj.data, key, JweAlgorithm.A256KW, JweEncryption.A256GCM);


            return jwt;
        }


        static string EncryptKey(string key)
        {

            string publiccertstr_UAT = "MIIDojCCAoqgAwIBAgIIBmMSCJVcNv4wDQYJKoZIhvcNAQELBQAwOzELMAkGA1UE"
                + "BhMCSU4xETAPBgNVBAoMCGluZHVzaW5kMRkwFwYDVQQDDBBpbmR1c2luZC1lbmMt"
                + "ZGVjMB4XDTIyMDcxMjA3NDAxMVoXDTMyMDcwOTA3NDAxMVowOzELMAkGA1UEBhMC"
                + "SU4xETAPBgNVBAoMCGluZHVzaW5kMRkwFwYDVQQDDBBpbmR1c2luZC1lbmMtZGVj"
                + "MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAu60AzxMOMrBQ4zrsyh4y"
                + "ftU82X+bUz5NqVAa7kvrHJQVawqfQJiI6T72tFDULHxyiBXu+zOmPQH9WGIk9Rri"
                + "IIAUT6iRKtmLfk7ihZkVoYSbvN3mKFAhOGghBJmlJeEL301yhU38y2Nu/nx0mm/Y"
                + "/r5DsSAzhet+U5GNBL8fYo0uOZ9Ooziuv9h+nqX0u2tcIPJmausesw42ceXXDJul"
                + "YjHOMIRg8cyidWSIYLEdebxocOzXuq9hcpoxF45F5br9+syYuQSqzSYDj02xRcee"
                + "nU/rh78Al4cRcYDTmQ6OrZL+OrAcUjiqkR+mX+QKPI5vpo4I5cQMIzkSg+SQFevW"
                + "BwIDAQABo4GpMIGmMAwGA1UdEwQFMAMBAf8wHQYDVR0OBBYEFDlKyoJrELE0Ftrz"
                + "WSdZQNTGzCEYMGoGA1UdIwRjMGGAFDlKyoJrELE0FtrzWSdZQNTGzCEYoT+kPTA7"
                + "MQswCQYDVQQGEwJJTjERMA8GA1UECgwIaW5kdXNpbmQxGTAXBgNVBAMMEGluZHVz"
                + "aW5kLWVuYy1kZWOCCAZjEgiVXDb+MAsGA1UdDwQEAwICvDANBgkqhkiG9w0BAQsF"
                + "AAOCAQEAs3VlD7kLZZ7TH9S4KGm5s+5feJdl7Xnjq1f+GE8lSKC7hPgHoeiCHb2r"
                + "7TNWHszhHvBfMfYXPk0Pb60q2VaDZYQbcaetoZsyP33/S/ZxjMIL3KVb9sp7kMXI"
                + "JTby+SqXNxAipoO0RJapiaEBidOgRspYFAjjgeGGvmmxU6yLIsSM12jIxGSm0Mrd"
                + "zzEkzOMADlPj4TW8Mwo7rSls7nQ120qJTZRwpqu2FsiSxk4Krt/L0WbIjzXjnxqQ"
                + "O1sDVzmo0g35a0+MhfFJvsJFJ4GcLu+s22GPXYvVMXn6WFcxgW/CN2LggO1VDYCs"
                + "bmJIfMS8JWis0fdzPkCdPXWZvIY7OQ==";

            byte[] decodecert = Convert.FromBase64String(publiccertstr_UAT);
            X509Certificate2 cert2 = new X509Certificate2(decodecert);
            RSACryptoServiceProvider rSACrypto = (RSACryptoServiceProvider)cert2.PublicKey.Key;

            var encoded = JWT.Encode(key, rSACrypto, JweAlgorithm.RSA_OAEP_256, JweEncryption.A256GCM);

            return encoded;

        }
    }


    public class EncryptedPayload
    {
        public string data { get; set; }
        public string key { get; set; }
        public int bit { get; set; }
    }

    public class EncryptedResponse
    {
        public string data { get; set; }
    }

    public class PlainPayload
    {
        public string pgMerchantId { get; set; }
        public string txnId { get; set; }
        public string ts { get; set; }
        public string mebussname { get; set; }
        public string legalStrName { get; set; }
        public string merVirtualAdd { get; set; }
        public string awlmcc { get; set; }
        public string strCntMobile { get; set; }
        public string merchantType { get; set; }
        public string panNo { get; set; }
        public string gstNumber { get; set; }
        public string extMID { get; set; }
        public string extTID { get; set; }
        public string accNo { get; set; }
        public string ifscCode { get; set; }
        public string accType { get; set; }
        public string meEmailID { get; set; }
        public string onboardingType { get; set; }
        public string merchantGenre { get; set; }
        public string ownerShipType { get; set; }
        public string kycFlag { get; set; }
    }

}
